package uk.ac.leeds.ccg.andyt.vector;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Polygon;
import java.awt.Shape;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
//import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import javax.swing.JApplet;
import javax.swing.JFrame;
import uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDouble;
import uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDoubleFactory;
import uk.ac.leeds.ccg.andyt.vector.geometry.Network2D;
import uk.ac.leeds.ccg.andyt.vector.geometry.Network2D.Connection;
import uk.ac.leeds.ccg.andyt.vector.geometry.Point2D;

public class RenderNetwork2D extends AbstractRender {

    public HashSet<Network2D> _Network2D_HashSet;

    public RenderNetwork2D(
            JFrame _JFrame) {
        this._JFrame = _JFrame;
        this._JFrame.getContentPane().add("Center", this);
        this.init();
        _JFrame.pack();
        _JFrame.setSize(new Dimension(this.width, this.height));
        _JFrame.setVisible(true);
    }

    public RenderNetwork2D(
            JFrame _JFrame,
            int width,
            int height,
            HashSet<Network2D> _Network2D_HashSet) {
        this.width = width;
        this.height = height;
        this._JFrame = _JFrame;
        this._JFrame.getContentPane().add("Center", this);
        this.init();
        _JFrame.pack();
        _JFrame.setSize(new Dimension(this.width, this.height));
        _JFrame.setVisible(true);
        this._Network2D_HashSet = _Network2D_HashSet;
    }

    @Override
    public void paint(Graphics _Graphics) {
        super.paint(_Graphics);
        this._Graphics2D = (Graphics2D) _Graphics;
        // Draw
        draw();
    //drawNetwork2D();
    }

    public void draw() {
        Iterator aIterator = _Network2D_HashSet.iterator();
        Network2D aNetwork2D;
        while (aIterator.hasNext()) {
            aNetwork2D = (Network2D) aIterator.next();
            Set<Point2D> keys = aNetwork2D._Connection_HashMap.keySet();
            Iterator bIterator;
            bIterator = keys.iterator();
            Point2D aPoint2D;
            HashSet<Connection> a_Connection_HashSet;
            while (bIterator.hasNext()) {
                aPoint2D = (Point2D) bIterator.next();
                a_Connection_HashSet = (HashSet<Connection>) aNetwork2D._Connection_HashMap.get(aPoint2D);
                draw(
                        aPoint2D,
                        a_Connection_HashSet);
            }
        }
    }

    public void drawNetwork2D() {
        boolean _HandleOutOfMemoryError = false;
        long _NRows = 100;
        long _NCols = 200;
        Grid2DSquareCellDoubleFactory aGrid2DSquareCellDoubleFactory =
                new Grid2DSquareCellDoubleFactory(new HashSet(), _HandleOutOfMemoryError);
        Grid2DSquareCellDouble aGrid2DSquareCellDouble =
                (Grid2DSquareCellDouble) aGrid2DSquareCellDoubleFactory.create(_NRows, _NCols);
        Network2D aNetwork2D = new Network2D(
                aGrid2DSquareCellDouble);
        Set<Point2D> keys = aNetwork2D._Connection_HashMap.keySet();
        Iterator aIterator;
        aIterator = keys.iterator();
        Point2D aPoint2D;
        HashSet<Connection> a_Connection_HashSet;
        while (aIterator.hasNext()) {
            aPoint2D = (Point2D) aIterator.next();
            a_Connection_HashSet = (HashSet<Connection>) aNetwork2D._Connection_HashMap.get(aPoint2D);
            draw(aPoint2D,
                    a_Connection_HashSet);
        }
    }

    public void drawNetwork2D(
            Network2D a_Network2D) {
        Set<Point2D> keys = a_Network2D._Connection_HashMap.keySet();
        Iterator a_Iterator = keys.iterator();
        while (a_Iterator.hasNext()) {
            Point2D a_Point2D = (Point2D) a_Iterator.next();
            draw(a_Point2D,
                    (HashSet<Connection>) a_Network2D._Connection_HashMap.get(a_Point2D));
        }
    }

    public void draw(
            Point2D a_Point2D,
            HashSet<Connection> a_Connection_HashSet) {
        draw(a_Point2D,
                a_Connection_HashSet,
                1);
    }

    public void draw(
            Point2D a_Point2D,
            HashSet<Connection> a_Connection_HashSet,
            int scale) {
        this._Graphics2D.setPaint(Color.RED);
        int ax = (int) a_Point2D._x.intValue() * scale;
        int ay = (int) a_Point2D._y.intValue() * scale;
        int bx;
        int by;
        Iterator aIterator;
        aIterator = a_Connection_HashSet.iterator();
        while (aIterator.hasNext()) {
            Connection a_Connection = (Connection) aIterator.next();
            bx = (int) a_Connection._Point2D._x.intValue() * scale;
            by = (int) a_Connection._Point2D._y.intValue() * scale;
            this._Graphics2D.drawLine(ax, ay, bx, by);
        }
    }

    public void drawLine(Point2D[] tPoints) {
        this._Graphics2D.setPaint(Color.RED);
        int x0 = (int) tPoints[0]._x.intValue();
        int y0 = (int) tPoints[0]._y.intValue();
        int x1;
        int y1;
        for (int i = 0; i < tPoints.length; i++) {
            x1 = (int) tPoints[1]._x.intValue();
            y1 = (int) tPoints[1]._y.intValue();
            this._Graphics2D.drawLine(x0, y0, x1, y1);
            x0 = x1;
            y0 = y1;
        }
    }
}
