package uk.ac.leeds.ccg.andyt.vector.geometry;

import java.math.BigDecimal;
import java.math.MathContext;
import uk.ac.leeds.ccg.andyt.ext.math.BigDecimal0;

public class Point2D
        extends AbstractGeometry2D
        implements Comparable {

    public BigDecimal _x;
    public BigDecimal _y;

    public Point2D(
            Point2D aPoint2D) {
        _x = new BigDecimal(aPoint2D._x.toString());
        _y = new BigDecimal(aPoint2D._y.toString());
        applyDecimalPlacePrecision();
    }

    public Point2D(
            Point2D aPoint2D,
            int _DecimalPlacePrecision) {
        _x = new BigDecimal(aPoint2D._x.toString());
        _y = new BigDecimal(aPoint2D._y.toString());
        this._DecimalPlacePrecision = _DecimalPlacePrecision;
        applyDecimalPlacePrecision();
    }

        public Point2D(
            BigDecimal x,
            BigDecimal y) {
        this._x = new BigDecimal(x.toString());
        this._y = new BigDecimal(y.toString());
        applyDecimalPlacePrecision();
    }

        public Point2D(
            BigDecimal x,
            BigDecimal y,
            int _DecimalPlacePrecision) {
        this._x = new BigDecimal(x.toString());
        this._y = new BigDecimal(y.toString());
        this._DecimalPlacePrecision = _DecimalPlacePrecision;
        applyDecimalPlacePrecision();
    }

    public Point2D(
            double x,
            double y) {
        _x = new BigDecimal(x);
        _y = new BigDecimal(y);
        applyDecimalPlacePrecision();
    }

    public Point2D(
            double x,
            double y,
            int _DecimalPlacePrecision) {
        _x = new BigDecimal(x);
        _y = new BigDecimal(y);
        this._DecimalPlacePrecision = _DecimalPlacePrecision;
        applyDecimalPlacePrecision();
    }


    @Override
    public String toString() {
        return new String(
                "Point2D(" +
                super.toString() +
                "x(" + _x.toString() + ")," +
                "y(" + _y.toString() + "))");
    }

    @Override
    public boolean equals(Object o) {
        if (compareTo(0) == 0) {
            return true;
        }
        return false;
    }

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 67 * hash + (this._x != null ? this._x.hashCode() : 0);
        hash = 67 * hash + (this._y != null ? this._y.hashCode() : 0);
        return hash;
    }

    /**
     * Default is 1.
     */
    public int compareTo(Object o) {
        if (o instanceof Point2D) {
            Point2D aPoint2D = (Point2D) o;
            int compareTo_y = _y.compareTo(aPoint2D._y);
            if (compareTo_y != 0) {
                return compareTo_y;
            } else {
                return _x.compareTo(aPoint2D._x);
            }
        }
        return 1;
    }

    public boolean getIntersects(LineSegment2D a_LineSegment2D){
        return a_LineSegment2D.getIntersects(this);
    }

    public BigDecimal getDistance(
            Point2D a_Point2D,
        MathContext a_MathContext){
        BigDecimal diffx = this._x.subtract(a_Point2D._x,a_MathContext);
        BigDecimal diffy = this._y.subtract(a_Point2D._y,a_MathContext);
        return BigDecimal0.sqrt0(diffx.multiply(diffx,a_MathContext).add(diffy.multiply(diffy,a_MathContext),a_MathContext), a_MathContext.getPrecision());
    }

    protected BigDecimal getGradient(Point2D a_Point2D){
        MathContext a_MathContext = new MathContext(_DecimalPlacePrecision + 5);
        BigDecimal xDiff0 = _x.subtract(
                a_Point2D._x,
                a_MathContext);
        BigDecimal yDiff0 = _y.subtract(
                a_Point2D._y,
                a_MathContext);
        if (yDiff0.compareTo(BigDecimal.ZERO) == 0) {
            return BigDecimal.ONE;
        } else {
//            if (xDiff0.compareTo(BigDecimal.ZERO) == 0) {
//                return BigDecimal.ZERO;
//            } else {
                return xDiff0.divide(
                    yDiff0,
                    a_MathContext);
//            }
        }
    }

    @Override
    public Envelope2D getEnvelope2D() {
        return new Envelope2D(
                _x,
                _y);
    }

    public void applyDecimalPlacePrecision() {
        _x = _x.setScale(
                _DecimalPlacePrecision,
                _RoundingMode);
        _y = _y.setScale(
                _DecimalPlacePrecision,
                _RoundingMode);
    }

//    @Override
//    public double getX() {
//        return _x.doubleValue();
//    }
//
//    @Override
//    public double getY() {
//        return _y.doubleValue();
//    }
//
//    @Override
//    public void setLocation(double x, double y) {
//        _x = new BigDecimal(x);
//        _y = new BigDecimal(x);
//    }
}
